> For the complete documentation index, see [llms.txt](https://docs.kogno.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.kogno.io/replies-notifications/messenger_generic_template.md).

# messenger\_generic\_template

### <mark style="color:orange;">`messenger_generic_template(elements=Hash|Array, image_aspect_ration=Enum, quick_replies=Array)`</mark>

## **Platforms**

<table><thead><tr><th width="362.78343949044586">Platform</th><th data-type="checkbox">Supported</th></tr></thead><tbody><tr><td>Messenger</td><td>true</td></tr><tr><td>WhatsApp</td><td>false</td></tr><tr><td>Telegram</td><td>false</td></tr></tbody></table>

## Usage

```ruby
@reply.messenger_generic_template(
  {
    title: "The Title",
    subtitle: "This is the subtitle",
    image_url: "https://pbs.twimg.com/profile_images/1533726469641338881/Q9dM6DpM_400x400.jpg",          
    default_action: {
      type: :web_url,
      url: "https://kogno.io",
      :webview_height_ratio => :tall,
      messenger_extensions: true
    },
    buttons: [
      {
        type: :web_url,
        url: "https://kogno.io",
        title: "Call to Action ➡️",
        webview_height_ratio: :tall,
        messenger_extensions: true
      }
    ]
  },
  :square,
  [
    {
      title: "Button bellow",
      payload: "some_context/some_payload"
    }
  ]
)
```

## Params

<table><thead><tr><th width="150">Name</th><th>Description</th></tr></thead><tbody><tr><td><mark style="color:orange;"><code>elements</code></mark><br><em>Hash|Array</em></td><td><p><strong>Required.</strong></p><p>Can be Hash or an Array of Hashes.  View the full structure of <code>elements</code> in  <a href="https://developers.facebook.com/docs/messenger-platform/reference/templates/generic#elements">Messenger Platform</a> documentation.</p></td></tr><tr><td><mark style="color:orange;"><code>image_aspect_ratio</code></mark><br><em>Enum</em></td><td><strong>Optional.</strong><br>The aspect ratio used to render images specified by <code>element.image_url</code>. Must be <code>horizontal</code> (1.91:1) or <code>square</code> (1:1). Defaults to <code>horizontal</code>.</td></tr><tr><td><mark style="color:orange;"><code>quick_replies</code></mark><br><em>Array</em></td><td><strong>Optional</strong>.<br>Array of buttons that appear below the carousel.</td></tr></tbody></table>

{% hint style="info" %}
Learn more about Messenger Generic Templates in the [official documentation](https://developers.facebook.com/docs/messenger-platform/reference/templates/generic).
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.kogno.io/replies-notifications/messenger_generic_template.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
